/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-roseus-remote-0.0.11-0raring-20150915-0955/msg/RawCommand.msg
 *
 */


#ifndef ROSEUS_REMOTE_MESSAGE_RAWCOMMAND_H
#define ROSEUS_REMOTE_MESSAGE_RAWCOMMAND_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace roseus_remote
{
template <class ContainerAllocator>
struct RawCommand_
{
  typedef RawCommand_<ContainerAllocator> Type;

  RawCommand_()
    : data()  {
      data.assign(0);
  }
  RawCommand_(const ContainerAllocator& _alloc)
    : data()  {
      data.assign(0);
  }



   typedef boost::array<uint8_t, 1024>  _data_type;
  _data_type data;




  typedef boost::shared_ptr< ::roseus_remote::RawCommand_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::roseus_remote::RawCommand_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct RawCommand_

typedef ::roseus_remote::RawCommand_<std::allocator<void> > RawCommand;

typedef boost::shared_ptr< ::roseus_remote::RawCommand > RawCommandPtr;
typedef boost::shared_ptr< ::roseus_remote::RawCommand const> RawCommandConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::roseus_remote::RawCommand_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::roseus_remote::RawCommand_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace roseus_remote

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'roseus_remote': ['/tmp/buildd/ros-hydro-roseus-remote-0.0.11-0raring-20150915-0955/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::roseus_remote::RawCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::roseus_remote::RawCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::roseus_remote::RawCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::roseus_remote::RawCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::roseus_remote::RawCommand_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::roseus_remote::RawCommand_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::roseus_remote::RawCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "3a98047919201ddd4c818d061ad4865b";
  }

  static const char* value(const ::roseus_remote::RawCommand_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x3a98047919201dddULL;
  static const uint64_t static_value2 = 0x4c818d061ad4865bULL;
};

template<class ContainerAllocator>
struct DataType< ::roseus_remote::RawCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "roseus_remote/RawCommand";
  }

  static const char* value(const ::roseus_remote::RawCommand_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::roseus_remote::RawCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint8[1024] data\n\
";
  }

  static const char* value(const ::roseus_remote::RawCommand_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::roseus_remote::RawCommand_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct RawCommand_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::roseus_remote::RawCommand_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::roseus_remote::RawCommand_<ContainerAllocator>& v)
  {
    s << indent << "data[]" << std::endl;
    for (size_t i = 0; i < v.data.size(); ++i)
    {
      s << indent << "  data[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROSEUS_REMOTE_MESSAGE_RAWCOMMAND_H
